import matplotlib.pyplot as plt
import seaborn as sb
import numpy as np


def corelograma(t, title=None, valmin=-1, valmax=1):
    plt.figure(title, figsize=(11, 6))
    # sb.heatmap(data=np.round(t, 2), vmin=valmin, vmax=valmax, cmap='PRGn', annot=True) # np.round(t,2)
    sb.heatmap(data=np.round(t, 2), vmin=valmin, vmax=valmax, cmap='bwr', annot=True)  # np.round(t,2)
    plt.title(title)
    plt.show()

def valori_proprii(alpha):
    plt.figure("Grafic linie", figsize=(11, 6))

    # 1 linie, 1 coloana, index=1
    # f1 = f.add_subplot(1, 1, 1, title="Valori proprii - Varianta Componentelor",
    #                    xlabel="Componente", ylabel="Valori proprii")

    plt.title("Valori proprii - Varianta Componentelor")
    plt.xlabel("Componente")
    plt.ylabel("Valori proprii")
    plt.plot(alpha, 'bo-')
    plt.xticks([k for k in range(len(alpha))])
    plt.axhline(1, color='r')
    plt.show()

def cercul_corelatiilor(R, k1, k2, title="Cercul corelatiilor", x_label=None, y_label=None):
    plt.figure(title, figsize=(6, 6))
    plt.title(title, fontsize=16, color='b', verticalalignment='bottom')
    T =[t for t in np.arange(0, np.math.pi*2, 0.01)]
    X = [np.cos(t) for t in T]
    Y = [np.sin(t) for t in T]
    plt.plot(X, Y)
    plt.axhline(0,color='g')
    plt.axvline(0,color='g')
    plt.scatter(R[:, k1], R[:, k2], c='r')
    # plt.xlabel(str(R[:, k1]), fontsize=12, color='r', verticalalignment='top')
    # plt.ylabel(str(R[:, k2]), fontsize=12, color='r', verticalalignment='bottom')
    plt.xlabel(x_label, fontsize=12, color='r', verticalalignment='top')
    plt.ylabel(y_label, fontsize=12, color='r', verticalalignment='bottom')
    for i in range(len(R)):
        plt.text(np.round(R[i, k1], 1), np.round(R[i, k2], 1), str(np.round(R[i], 1)))
        # plt.text(np.round(R[i, k1], 2), np.round(R[i, k2], 2))
    plt.show()

def histograma(y_objects, x_objects, x_label=None, y_label=None, title=None):
    # plt.rcdefaults()
    y_pos = np.arange(len(y_objects))
    plt.bar(y_pos, x_objects, align='center', alpha=0.5)
    plt.yticks(y_pos, y_objects)
    plt.xlabel(x_label)
    plt.title(title)
    plt.show()